package com.example.fieldagent.ui.damagedetails.adapter

import android.net.Uri
import android.util.Log
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.example.fieldagent.databinding.DamageImageAdapterBinding
import com.example.fieldagent.ui.damagedetails.DamageDetailsFragment
import com.example.fieldagent.utils.gone
import com.example.fieldagent.utils.visible


class DamageDetailsAdapter(
    val imageList: ArrayList<Uri?>,
    val damageDetailsFragment: DamageDetailsFragment
) : RecyclerView.Adapter<DamageDetailsAdapter.DamageViewHolder>() {

    class DamageViewHolder(val binding: DamageImageAdapterBinding) : RecyclerView.ViewHolder(binding.root) {

        fun bind(imageUrl: Uri) {
            binding.rlUploadImage.gone()
            binding.cardImage.visible()
            binding.ivCloseImage.visible()
            Glide.with(binding.root.context)
                .load(imageUrl)
                .into(binding.ivSetImage)  // Assuming you have an ImageView with id ivDamageImage in your layout
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DamageViewHolder {
        val binding = DamageImageAdapterBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return DamageViewHolder(binding)
    }

    override fun onBindViewHolder(holder: DamageViewHolder, position: Int) {
        if (imageList[position] != null) {

            val imageUrl = imageList[position]

            imageUrl?.let {
                holder.bind(it)
            }
            holder.binding.ivCloseImage.setOnClickListener {
                damageDetailsFragment.removeImage(position)
            }
        } else {
            holder.binding.rlUploadImage.visible()
            holder.binding.cardImage.gone()
            holder.binding.ivCloseImage.gone()

            holder.binding.rlUploadImage.setOnClickListener {
                damageDetailsFragment.clickItem(position)
            }
        }

    }

    override fun getItemCount(): Int = 5
}